#!/usr/local/gauche/bin/gosh
;; -*- coding: utf-8-unix -*-

(add-load-path ".." :relative #t)
(use tar)
(use gauche.collection)

;;;
;;; Create tar from buffer.
;;;
(let ((empty-dir (make-tar-virtual-entry-directory "temp/"))
      (out (open-output-tar-virtual-entry "foo.txt"))
      (out2 (open-output-tar-virtual-entry "temp/bar.txt"))
      (tar (open-output-tar-writer "ventry.tar")))
  (format out "foobar")
  (add-content tar empty-dir)
  (add-content tar out)
  (call-with-input-file "../tario.scm"
    (^(in)
      (copy-port in out2)))
  (add-content tar out2)
  (close-output-tar-writer tar)
  (close-output-tar-virtual-entry out)
  (close-output-tar-virtual-entry out2))

;;;
;;; Create tar-gz from buffer.
;;;
(let ((empty-dir (make-tar-virtual-entry-directory "temp/"))
      (out (open-output-tar-virtual-entry "foo.txt"))
      (out2 (open-output-tar-virtual-entry "temp/bar.txt"))
      (tar (open-output-tar-gz-writer "ventry.tar.gz")))
  (format out "foobar")
  (add-content tar empty-dir)
  (add-content tar out)
  (call-with-input-file "../tario.scm"
    (^(in)
      (copy-port in out2)))
  (add-content tar out2)
  (close-output-tar-writer tar)
  (close-output-tar-virtual-entry out)
  (close-output-tar-virtual-entry out2))

;;;
;;; Create tar-gz from buffer using tar-gz-builder.
;;;
(let ((empty-dir (make-tar-virtual-entry-directory "temp/"))
      (out (open-output-tar-virtual-entry "foo.txt"))
      (out2 (open-output-tar-virtual-entry "temp/bar.txt"))
      (tar (open-output-tar-gz-builder "ventry_build.tar.gz")))
  (format out "foobar")
  (add-content tar empty-dir)
  (close-output-tar-virtual-entry empty-dir)
  (add-content tar out)
  (close-output-tar-virtual-entry out)
  (call-with-input-file "../tario.scm"
    (^(in)
      (copy-port in out2)))
  (add-content tar out2)
  (close-output-tar-virtual-entry out2)
  (close-output-tar-gz-builder tar))
