#!/usr/local/gauche/bin/gosh
;; -*- coding: utf-8-unix -*-

;;; one line to give the Gauche-tar and an idea of what it does.
;;; Copyright (C) 2018 aaauuue 
;;;
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(select-module tar)

(define-class <tar-virtual-entry> (<virtual-output-port>)
  ((uid :init-form (or (sys-getuid) 1000))
   (gid :init-form (or (sys-getgid) 1000))
   (mode :init-form #o744)
   (atime :init-form (sys-time))
   (ctime :init-form (sys-time))
   (mtime :init-form (sys-time))
   (name :init-form "")
   (size :allocation :virtual
         :slot-ref (^(o) (if (~ o 'buffer)
                           (uvector-length (get-output-uvector (~ o'buffer)))
                           0)))
   (type :init-form 'regular) ;; 'regular or 'directory
   (buffer :init-form #f)     ;; content buffer. If type is 'directory this slot
                              ;; sets `#f`
   ))

(define (open-output-tar-virtual-entry name)
  (let* ((out (open-output-uvector))
         (tve (make <tar-virtual-entry>
                :putb (^b (if out (write-byte b out))))))
    (set! (~ tve 'buffer) out)
    (set! (~ tve 'name) name)
    tve))

(define (get-output-tar-virtual-entry ventry)
  (if (~ ventry 'buffer)
    (get-output-uvector (~ ventry 'buffer))
    #f))

(define (close-output-tar-virtual-entry ventry)
  (if (~ ventry 'buffer)
    (close-output-port (~ ventry 'buffer)))
  (set! (~ ventry 'buffer) #f))

(define (make-tar-virtual-entry-directory name)
  (let ((ventry (make <tar-virtual-entry> :putb (^b ))))
    (set! (~ ventry 'type) 'directory)
    (set! (~ ventry 'name) name)
    ventry))


